#!/usr/bin/env node
let fs = require('fs');
var cli = require('cli');
var cmd = require('node-cmd');
var path = require('path');
var xmlReader = require('read-xml');
const xml = require("xml-parse");
var FILE = 'config.xml';
options = cli.parse();
try {
    if (fs.existsSync(FILE)) {
        /**
         * IOS
         */
        if (options.platform && options.platform === 'ios' && options.action && options.action === 'add') {
            cli.ok("Working ....");
            cmd.get('cordova platforms add ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform exists');
                } else {
                    /**
                     * App run 
                     */
                    applicationResource(options.platform);
                    cli.ok("successfully ....");
                }
            });
        }
        /**
         * ANDROID
         */
        if (options.platform && options.platform === 'android' && options.action && options.action === 'add') {
            cli.ok("Working ....");
            cmd.get('cordova platforms add ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform exists');
                } else {
                    /**
                     * App run 
                     */
                    applicationResource(options.platform);
                    cli.ok("successfully ....");
                }
            });
        }
        /**
         * IOS
         */
        if (options.platform && options.platform === 'ios' && options.action && options.action === 'remove') {
            cli.ok("Working ....");
            cmd.get('cordova platforms remove ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform is not exists');
                } else {
                    /**
                     * App run 
                     */
                    cli.ok("successfully ....");
                }
            });
        }
        /**
         * ANDROID
         */
        if (options.platform && options.platform === 'android' && options.action && options.action === 'remove') {
            cli.ok("Working ....");
            cmd.get('cordova platforms remove ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform is not exists');
                } else {
                    /**
                     * App run 
                     */
                    cli.ok("successfully ....");
                }
            });
        }
        /**
         * IOS
         */
        if (options.platform && options.platform === 'ios' && options.action && options.action === 'reinstall') {
            cli.ok("Working ....");
            cmd.get('cordova platforms remove ' + options.platform
                + ' && cordova platforms add ' + options.platform, (err, data, stderr) => {
                    if (err) {
                        cli.error('maybe platform exists');
                    } else {
                        /**
                         * App run 
                         */
                        applicationResource(options.platform);
                        cli.ok("successfully ....");
                    }
                });
        }
        /**
         * ANDROID
         */
        if (options.platform && options.platform === 'android' && options.action && options.action === 'reinstall') {
            cli.ok("Working ....");
            cmd.get('cordova platforms remove ' + options.platform
                + ' && cordova platforms add ' + options.platform, (err, data, stderr) => {
                    if (err) {
                        cli.error('maybe platform exists');
                    } else {
                        /**
                         * App run 
                         */
                        applicationResource(options.platform);
                        cli.ok("successfully ....");
                    }
                });
        }
        /**
         * OSX
         */
        if (options.platform && options.platform === 'osx' && options.action && options.action === 'add') {
            cli.ok("Working ....");
            cmd.get('cordova platforms add ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform exists');
                } else {
                    /**
                     * App run 
                     */
                    applicationResource(options.platform);
                    cli.ok("successfully ....");
                }
            });
        }
        if (options.platform && options.platform === 'osx' && options.action && options.action === 'remove') {
            cli.ok("Working ....");
            cmd.get('cordova platforms remove ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform is not exists');
                } else {
                    /**
                     * App run 
                     */
                    applicationResource(options.platform);
                    cli.ok("successfully ....");
                }
            });
        }
        /**
         * WINDOWS
         */
        if (options.platform && options.platform === 'windows' && options.action && options.action === 'add') {
            cli.ok("Working ....");
            cmd.get('cordova platforms add ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform exists');
                } else {
                    /**
                     * App run 
                     */
                    //applicationResource(options.platform);
                    cli.ok("successfully ....");
                }
            });
        }
        if (options.platform && options.platform === 'windows' && options.action && options.action === 'remove') {
            cli.ok("Working ....");
            cmd.get('cordova platforms remove ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform is not exists');
                } else {
                    /**
                     * App run 
                     */
                    //applicationResource(options.platform);
                    cli.ok("successfully ....");
                }
            });
        }
        /**
         * Web 
         */
        if (options.platform && options.platform === 'browser' && options.action && options.action === 'add') {
            cli.ok("Working ....");
            cmd.get('cordova platforms add ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform exists');
                } else {
                    /**
                     * App run 
                     */
                    //applicationResource(options.platform);
                    cli.ok("successfully ....");
                }
            });
        }
        if (options.platform && options.platform === 'browser' && options.action && options.action === 'remove') {
            cli.ok("Working ....");
            cmd.get('cordova platforms remove ' + options.platform, (err, data, stderr) => {
                if (err) {
                    cli.error('maybe platform is not exists');
                } else {
                    /**
                     * App run 
                     */
                    cli.ok("successfully ....");
                }
            });
        }
    } else {
        throw "You need create vn native project";
    }
} catch (e) {
    cli.error(e);
}   
/**
 * Add resource 
 */

function applicationResource(platform){
    xmlReader.readXML(fs.readFileSync(FILE), function(err, data) {
        if (err) {
          console.error(err);
        }
        let contentXml = xml.parse(data.content);
        if(contentXml[2].childNodes[1].innerXML) {
            let appName = contentXml[2].childNodes[1].innerXML;
            if(platform === 'ios') {
                cmd.get('cp -R ./resources/ios/icon/*.png "./platforms/ios/' + appName + '/Images.xcassets/AppIcon.appiconset"',(err,res) => {
                    if(err) {
                        cli.error("Project not found resource");
                    } else {
                        
                    }
                });
                cmd.get('cp -R ./resources/ios/wait/*.png "./platforms/ios/' + appName + '/Images.xcassets/LaunchImage.launchimage"',(err,res) => {
                    if(err) {
                        cli.error("Project not found resource");
                    } else {
                        
                    }
                });
            } else if(platform === 'osx') {
                cmd.get('cp -R ./resources/osx/icon/*.png "./platforms/osx/' + appName + '/Images.xcassets/AppIcon.appiconset"',(err,res) => {
                    if(err) {
                        cli.error("Project not found resource");
                    } else {
                        
                    }
                });
            } else if(platform === 'android') {
                cmd.get('cp -R ./resources/android/* ./platforms/android/app/src/main/res',(err,res) => {
                    if(err) {
                        cli.error("Project not found resource");
                    } else {

                    }
                });
            }   
        }
    });
}