#!/usr/bin/env node
let fs = require('fs');
var cli = require('cli');
var cmd = require('node-cmd');
options = cli.parse();
var text = __dirname + '/info/BuildInfo.txt';
try {
    if (fs.existsSync('config.xml')) {
        //file exists
        if(options.platform && options.platform !== '') {
            if(options.platform === 'ios' || options.platform === 'android' || 
            options.platform === 'osx' || options.platform === 'windows' ||  options.platform === 'browser') {
                cli.ok("Building ....");
                cmd.get('vn-native-2-buildInfo',(err,data) => {
                    if(err){
                        
                    } else {
                        buildInfoText();
                    }
                });
                cmd.get('npm run build && cordova build ' + options.platform,(err, data, stderr) => {
                    if(err) {
                        console.log('error : ',err);
                    } else {
                        /**
                         * App builded 
                         */
                        buildInfoText();
                    }
                });
            }
        }
    } else {
        throw "You need create vn native project";
    }
} catch (e) {
    console.log(e);
}   

function buildInfoText(){

    if(fs.existsSync(text)) {
        fs.readFile(text, (err,data) => {
                if(err) {
                        console.log(err);
                } else {
                        cli.ok(data.toString());
                }
        });
    }
}