#!/usr/bin/env node
let fs = require('fs');
var cli = require('cli');
var cmd = require('node-cmd');
options = cli.parse();
try {
    if (fs.existsSync('config.xml')) {

        if (options.plugin && options.plugin !== '' && options.action && options.action === 'install') {
            cli.ok("Installing ....");
            cmd.get('npm install ' + options.plugin, (err, data, stderr) => {
                if (err) {
                    console.log('error : ', err);
                } else {
                    /**
                     * App run 
                     */
                    cli.ok("successfully ....");
                }
            });
            resetNPM();
        }
        if (options.plugin && options.plugin !== '' && options.action && options.action === 'remove') {
            cli.ok("Installing ....");
            cmd.get('npm remove ' + options.plugin, (err, data, stderr) => {
                if (err) {
                    console.log('error : ', err);
                } else {
                    /**
                     * App run 
                     */
                    cli.ok("successfully ....");
                }
            });
            resetNPM();
        }

        function resetNPM() {
            cmd.get('npm audit fix ', (err, data, stderr) => {
                if (err) {
                } else {

                }
            });
        }
    } else {
        throw "You need create vn native project";
    }
} catch (e) {
    console.log(e);
}   